;.dseg
;.org	SRAM_START
;retAddrL:	.BYTE 0x1	;  
;retAddrH:	.BYTE 0x1	;  
;skipAddrL:	.BYTE 0x1	;  
;skipAddrH:	.BYTE 0x1	;  
;subAddrL:	.BYTE 0x1	;  
;subAddrH:	.BYTE 0x1	;  
;w1buf1:		.BYTE 0x9	;  
;w1temp1:		.BYTE 0x1	;   1- 
;w1temp2:		.BYTE 0x1	;   2- 
;w1temp3:		.BYTE 0x1	;   3- 
;w1temp4:		.BYTE 0x1	;   4- 
;w1err1:		.BYTE 0x1	;    1- 
;IndBuf:		.BYTE 0x3	; 
;.eseg
;.org	0
;.equ		w1EElen	=	8
;w1Eecount:		.BYTE 0x1		;  1-wire(1-254)
;w1addrEe1:		.BYTE w1EElen	;  1-wire 1
;w1addrEe2:		.BYTE w1EElen	;  1-wire 2
;w1addrEe3:		.BYTE w1EElen	;  1-wire 3
;w1addrEe4:		.BYTE w1EElen	;  1-wire 4
;**********************************************************************
.def	w1CRCtmp1	=	r20
.def	w1CRCtmp	=	r21

.def	w1rdbuf	=	r22	;  -  :)
.def	w1cnt	=	r23	; 
.def	w1del	=	r24	;   
.def	skipL	=	r30	;ZL		26	;XL
.def	skipH	=	r31	;ZH		27	;XH
.def	subL	=	r30	;ZL		28	;YL
.def	subH	=	r31	;ZH		29	;YH
.def	indL	=	r30	;ZL
.def	indH	=	r31	;ZH
;**********************************************************************
; 
.equ	w1quantity		=	4	;4  DS-1820
; 
.equ	w1wait5us		=	-10		;80   5    8
.equ	w1wait50us		=	-100	;800   50   8
.equ	w1wait55us		=	-110	;880   55   8
.equ	w1wait60us		=	-120	;960   60   8
.equ	w1wait70us		=	-140	;1120   70   8
.equ	w1wait120us		=	-30		;1920   120   64
.equ	w1wait240us		=	-60		;3840   240   64
.equ	w1wait480us		=	-120	;7680   480   64
.equ	w1wait752us		=	-188	;12032   752   64
;**********************************************************************
;	
.macro	Ini_TMR0_8			; Timer0   8
		out		TCNT0,w1del		;  
		ldi		w1del,0b00000010	;8 Prescaler
		out		TCCR0,w1del		; 
		in		w1del,TIMSK
		ori		w1del,(1<<TOIE0)	;   
		out		TIMSK,w1del		; 0
.endm
.macro	Ini_TMR0_64			; Timer0   64
		out		TCNT0,w1del		;  
		ldi		w1del,0b00000011	;64 Prescaler
		out		TCCR0,w1del		; 
		in		w1del,TIMSK
		ori		w1del,(1<<TOIE0)	;   
		out		TIMSK,w1del		; 0
.endm
.macro	Stop_TMR0			;  Timer0
		clr		w1del
		out		TCCR0,w1del		; 
.endm
;.macro	retAddrIni			;  
;		ldi		temp,Low(retAddr)
;		sts		retAddrL,temp
;		ldi		temp,High(retAddr)
;		sts		retAddrH,temp
;.endm
.macro	retAddrLoad			;  
		lds		indL,retAddrL		;  
		push	indL				; 
		lds		indH,retAddrH		;  
		push	indH				;  
.endm
;.macro	retAddrSaveStack	;    
;		pop		indH				; 
;		pop		indL				;  
;		sts		retAddrH,indH		;  
;		sts		retAddrL,indL		; 
;.endm
.macro	retAddrSave			;  
		sts		retAddrH,indH		;  
		sts		retAddrL,indL		; 
.endm
.macro	subAddrGet			;    
		pop		subH				;  
		pop		subL				; - 
.endm
.macro	subAddrSet			;     
		push	subL				;  
		push	subH				; - 
.endm
.macro	subAddrLoad			;  
		lds		subL,subAddrL
		lds		subH,subAddrH
.endm
.macro	subAddrSave			;  
		sts		subAddrL,subL
		sts		subAddrH,subH
.endm
.macro	skipAddrSet			;    
		push	skipL				;  
		push	skipH				; - 
.endm
.macro	skipAddrLoad			;  
		ldi		skipL,Low(SkipSub)
		ldi		skipH,High(SkipSub)
.endm
.macro	skipAddrSave			;  
		sts		skipAddrL,skipL
		sts		skipAddrH,skipH
.endm
;**********************************************************************
;    1-wire   
;**********************************************************************
w1_Timer_Overflow:
		in		tempSreg,SREG		; SREG
		subAddrGet				;    
		retAddrLoad					;    
		ret							;  
;****************************************
Del64:
		subAddrGet					;  
		subAddrSave					;  
		Ini_TMR0_64						; 
		ldi		indH,High(Del64_1)		;  
		ldi		indL,Low(Del64_1)		;  
		rjmp	w1save					;    
Del64_1:
		rjmp	w1stop					;  
;****************************************
; Output : T - presence bit	( -   "w1use")
;****************************************
w1Reset:
	;	sbr		w1flag,(1<<w1work)		;   1-wire
		subAddrGet					;  
		subAddrSave					;  
		cbi		w1Port,w1				; 
		sbi		w1Dir,w1				; "0"  
		ldi		w1del,w1wait480us		;480 (470)
		Ini_TMR0_64						; 
		ldi		indH,High(w1Reset1)		;  
		ldi		indL,Low(w1Reset1)		;  
		rjmp	w1save					;    
w1Reset1:
		cbi		w1Dir,w1				; "1"   ()
		ldi		w1del,w1wait70us		;.  - 70us
		Ini_TMR0_8						; 
		ldi		indH,High(w1Reset2)		;  
		ldi		indL,Low(w1Reset2)		;  
		rjmp	w1save					;    
w1Reset2:
		set							;  T
		sbis	w1Pin,w1			;  ,   "1"
		clt							;  T
		bld		w1flag,w1use		; T   ( "w1use" -  )
		ldi		w1del,w1wait240us		;240 (240)
		Ini_TMR0_64						; 
		ldi		indH,High(w1Reset3)		;  
		ldi		indL,Low(w1Reset3)		;  
		rjmp	w1save					;    
w1Reset3:
		;rjmp	w1stop					;  
;****************************************
w1stop:	Stop_TMR0		; Timer0
		subAddrLoad					;  
		subAddrSet					;  
w1out:	out		SREG,tempSreg		; SREG
		reti							;  
;****************************************
w1save:	retAddrSave						;  
		skipAddrLoad				;  
		skipAddrSet					;  
		out		SREG,tempSreg		; SREG
		reti							;  
;****************************************
;    1-wire  	(w1rdbuf)
;****************************************
w1readByte:
		subAddrGet					;  
		subAddrSave					;  
		ldi		w1cnt,8				; 
w1readLoop:
;	rcall	w1ReadBit
;****************************************
w1ReadBit:			; (5us)   
		sbi		w1Dir, w1				;   "0"  5 us
		ldi		w1del,w1wait5us			;.  - 5us
		Ini_TMR0_8						; 
		ldi		indH,High(w1ReadBit1)	;  
		ldi		indL,Low(w1ReadBit1)	;  
		rjmp	w1save					;    
w1ReadBit1:			; (5us)   
		cbi		w1Dir, w1				; "1"   ()
		ldi		w1del,w1wait5us			;.  - 5us
		Ini_TMR0_8						; 
		ldi		indH,High(w1ReadBit2)	;  
		ldi		indL,Low(w1ReadBit2)	;  
		rjmp	w1save					;    
w1ReadBit2:
		lsr		w1rdbuf		; 
		sbic	w1Pin,w1	;,   ="0"
		sbr		w1rdbuf,$80		; 1 (  7  "1")
		bst		w1rdbuf,7			;  
		rcall	GetCRC				;  
		ldi		w1del,w1wait50us		;.  - 50us
		Ini_TMR0_8						; 
		ldi		indH,High(w1ReadBit3)	;  
		ldi		indL,Low(w1ReadBit3)	;  
		rjmp	w1save					;    
w1ReadBit3:
;****************************************
		dec		w1cnt					; 
		brne	w1ReadLoop				;
		rjmp	w1stop					;  
;****************************************
;    1-wire  	(w1rdbuf)
;****************************************
w1writeByte:
	subAddrGet						;  
	subAddrSave						;  
		ldi		w1cnt,8				; 
w1WriteLoop:
		bst		w1rdbuf,0			;   
		rcall	GetCRC				;  
		ror		w1rdbuf				;     
;****************************************
w1WriteBit:
		brcs	w1WriteOne				;    -    "1"
w1WriteZero:		; (60us)   
		sbi		w1Dir, w1				; "0"  
		ldi		w1del,w1wait60us		;.  - 60us
		Ini_TMR0_8						; 
		ldi		indH,High(w1WriteZero1)	;  
		ldi		indL,Low(w1WriteZero1)	;  
		rjmp	w1save					;    
w1WriteZero1:
		cbi		w1Dir, w1				; "1"   ()
		rjmp	w1WriteEnd
w1WriteOne:			; (5us)   
		sbi		w1Dir, w1				; "0"  
		ldi		w1del,w1wait5us			;.  - 5us
		Ini_TMR0_8						; 
		ldi		indH,High(w1WriteOne1)	;  
		ldi		indL,Low(w1WriteOne1)	;  
		rjmp	w1save					;    
w1WriteOne1:
		cbi		w1Dir, w1				; "1"   ()
w1WriteEnd:
		ldi		w1del,w1wait60us		;.  - 60us
		Ini_TMR0_8						; 
		ldi		indH,High(w1WriteEnd1)	;  
		ldi		indL,Low(w1WriteEnd1)	;  
		rjmp	w1save					;    
w1WriteEnd1:
;****************************************
		dec		w1cnt					; 
		brne	w1WriteLoop				;
		rjmp	w1stop					;  
;***************************************************************
;    1  (  )
;  w1CRCtmp -  
;***************************************************************
GetCRC:
		clr		w1CRCtmp1			;    CRC
		bld		w1CRCtmp1,0			;  
		eor		w1CRCtmp1,w1CRCtmp	;    
		ror		w1CRCtmp1			; - "0"  "1"
		mov		w1CRCtmp1,w1CRCtmp	;  
		brcc	Z0					;  "0" - 
		ldi		w1del,$18			;  "1" -  
		eor		w1CRCtmp1,w1del		;   
Z0:		ror		w1CRCtmp1			;     
		mov		w1CRCtmp,w1CRCtmp1	;   
		ret
;****************************************
;   
;****************************************
Calk:	ldi		w1cnt,8		;   (8 bit)
		clr		r0			; 
		clr		r1			; 
Rot21:	rol		w1rdbuf			; 
		rol		r0				;  0  1
		rol		r1				;  2
		dec		w1cnt
		brne	Rot22
rjmp	tSave					;ret
;****************************************
Rot22:	mov		skipL,r0
		rcall	DecodeOneByte		; 0  1
		mov		r0,skipL
		mov		skipL,r1
		rcall	DecodeOneByte		;  2
		mov		r1,skipL
		rjmp	Rot21
;****************************************
;  
DecodeOneByte:
		ldi		skipH,$03
		add		skipH,skipL
		sbrc	skipH,3
		mov		skipL,skipH
		ldi		skipH,$30
		add		skipH,skipL
		sbrc	skipH,7
		mov		skipL,skipH
		ret
;****************************************
;    
tSave:
		ldi		YL,Low(TempBuf)		;    1 DS1820
		ldi		YH,High(TempBuf)
		mov		w1rdbuf,r0			;  
		andi	w1rdbuf,$0F			;  
		st		Y+,w1rdbuf			;  

		mov		w1rdbuf,r0			;  
		swap	w1rdbuf				;  
		andi	w1rdbuf,$0F			;  
		st		Y+,w1rdbuf			;  

		mov		w1rdbuf,r1			;  
		andi	w1rdbuf,$0F			;  
		st		Y,w1rdbuf			;  

		ret
;****************************************
GetTemp:	;    EEPROM
rcall	GetDScode
rcall	Check_w1addr
ret

SkipSub:
rjmp	SkipSub
;ret





ppro:
		rcall	w1StartTemp		;  

		in		temp,PINB
		andi	temp,0b00111100
		cpi		temp,0b00111000
		brne	ppro2
		ldi		w1rdbuf,1	;   
		rjmp	pprox
ppro2:
		cpi		temp,0b00110100
		brne	ppro3
		ldi		w1rdbuf,2	;   
		rjmp	pprox
ppro3:
		cpi		temp,0b00101100
		brne	ppro4
		ldi		w1rdbuf,3	;   
		rjmp	pprox
ppro4:
		ldi		w1rdbuf,4	;   
	;	ldi		w1rdbuf,1	;   
pprox:
		rcall	Get1wTemp	; ...

rcall	Calk
rcall	Decode


ret
;*******************************************************
;   
;*******************************************************
w1StartTemp:
		rcall	w1Reset
		ldi		w1rdbuf,$CC
		rcall	w1WriteByte
		ldi		w1rdbuf,$44
		rcall	w1WriteByte
		ldi		w1del,w1wait752us		;752 
		rcall	Del64					;
		ret
;*******************************************************
;   1-wire    
; w1rdbuf -    EEPROM, 
;*******************************************************
tError:	pop		w1rdbuf
Get1wTemp:		;ldi		w1rdbuf,0	;   
		push	w1rdbuf			;  
		rcall	GetDSaddr			;   DS
		rcall	w1Reset				; 1-wire
		ldi		w1rdbuf,0x55		;   DS
		rcall	w1WriteByte			;  
		ldi		w1rdbuf,8			;   CRC
		rcall	TrEE_1w				; DS  
		ldi		w1rdbuf,$BE			;  
		rcall	w1WriteByte			;  
		ldi		w1rdbuf,9		;     9   CRC
		ldi		YL,Low(w1buf1)		;   1 DS1820
		ldi		YH,High(w1buf1)		;   1 DS1820
		rcall	Ressieve1w			;
		sbrc	w1flag,w1error		;  CRC
		rjmp	tError
	;	ret
;*******************************************************
		lds		w1rdbuf,w1buf1		;  (Low)
		lds		w1cnt,w1buf1+1		;  (High)
		andi	w1rdbuf,0xF0		;   (  16)
		andi	w1cnt,0x0F			;   (  16)
		or		w1rdbuf,w1cnt		;  1  (  16)
		swap	w1rdbuf				;   (  16)
	;	ret
;****************************************
;  
		cbr		flag,(1<<minus)
	;	bst		w1rdbuf,7			;   ()
		sbrs	w1rdbuf,7			;    "1" -  
		rjmp	NoZnak
		com		w1rdbuf				;0xFF-
		inc		w1rdbuf				; +1
	;	bld		w1rdbuf,7			;   ()
		sbr		flag,(1<<minus)
NoZnak:	pop		r0					;  
		ldi		YL,Low(w1temp1)		;   
		ldi		YH,High(w1temp1)	;  
		clr		r1					;  
		add		YL,r0				;   
		adc		YH,r1				;  
		st		Y,w1rdbuf			; 
		ret
;*******************************************************
;   DS1820  EEPROM
;  w1rdbuf  ,  YH  YL  
;*******************************************************
GetDSaddr:
		dec		w1rdbuf			;  (  0-3)
		mov		r0,w1rdbuf			;  
GetEEadr:
		ldi		XL,Low(w1addrEe1)	;    EEPROM  1
		ldi		XH,High(w1addrEe1)
		ldi		w1rdbuf,w1EElen		;  
		mul		w1rdbuf,r0			;   ( )
		add		XL,r0				;    
		adc		XH,r1				;    
		ret
;*******************************************************
;   DS1820
;*******************************************************
GetDScode:
		ldi		YL,Low(w1buf1)		;  
		ldi		YH,High(w1buf1)		;  1-wire
		rcall	w1Reset				; 1-wire
		ldi		w1rdbuf,$33			; Read Rom
		rcall	w1WriteByte			;  
		ldi		w1rdbuf,w1EElen		; 8 
;*******************************************************
;    N ( YH  YL  )
;  w1rdbuf     CRC
;*******************************************************
Ressieve1w:
		dec		w1rdbuf				; - CRC  
		breq	RessieveLastByte
		mov		r1,w1rdbuf			; 
		clr		w1CRCtmp			;  CRC
GDSCloop:
		rcall	w1ReadByte			;   
		st		Y+,w1rdbuf			;  
		dec		r1					; 
		brne	GDSCloop			;   N-1 
		mov		r0,w1CRCtmp1		;   CRC
RessieveLastByte:
		rcall	w1ReadByte			; CRC  
		st		Y+,w1rdbuf			;  
		mov		w1CRCtmp,r0			;   CRC
		cbr		w1flag,(1<<w1error)	;  -  CRC
		cp		w1CRCtmp,w1rdbuf	;  
		breq	CRCok					;  - 
		sbr		w1flag,(1<<w1error)	;  -  CRC
CRCok:	ret
;*******************************************************
;    N ( YH  YL  )
;  w1rdbuf     CRC
;*******************************************************
Transmit1w:
		dec		w1rdbuf				; - CRC  
		breq	TransmitLastByte	; 1 -   
		mov		r1,w1rdbuf			; 
		clr		w1CRCtmp			;  CRC
TransLoop:
		ld		w1rdbuf,Y+			;   
		rcall	w1WriteByte			;  
		dec		r1					; 
		brne	TransLoop			;   N-1 
TransmitLastByte:
		mov		w1rdbuf,w1CRCtmp	;   CRC
		rcall	w1WriteByte			;  
		ret
;*******************************************************
;    N ( XH  XL    EEPROM)
;  w1rdbuf     CRC
;*******************************************************
TrEE_1w:
		dec		w1rdbuf				; - CRC  
		breq	TransmitLastByte	; 1 -    CRC
		mov		r1,w1rdbuf			; 
		clr		w1CRCtmp			;  CRC
TrEE_Loop:
		rcall	EPROMRead			;   EEPROM
		adiw	XL,1				;   EEPROM
		rcall	w1WriteByte			;  
		dec		r1					; 
		brne	TrEE_Loop			;   N-1 
		rjmp	TransmitLastByte	;   CRC
;*******************************************************
;       
;*******************************************************
Check_w1addr:
		set			;  t ( )
		cpi		w1rdbuf,0			;   
		breq	Cw1_NoAddr			;  (   )
		mov		r0,w1rdbuf			;  
		push	w1rdbuf				;  
Cw1_bufLoop:
		push	r0					;   
		dec		r0					;  (  0-3)
		rcall	GetEEadr			;    
		ldi		YL,Low(w1buf1)		;    1-wire
		ldi		YH,High(w1buf1)
		ldi		w1cnt,w1EElen-1		;    CRC
;****************************************
Cw1_byteLoop:
		ld		w1rdbuf,Y+				;   1-wire
		mov		r0,w1rdbuf				;  
		rcall	EPROMRead				;   EEPROM
		cp		w1rdbuf,r0			;     
		brne	Cw1_bufOk			;   -  
		adiw	XL,1				;   EEPROM
		dec		w1cnt				;C   
		brne	Cw1_byteLoop		;
;****************************************
		clt							;  (     )
Cw1_bufOk:
		pop		r0					;   
		dec		r0					;C 
		brne	Cw1_bufLoop			;
Cw1_Error:
		pop		w1rdbuf				;  
Cw1_NoAddr:
		brtc	Cw1_NoWrite			;      - 
		rcall	w1addrWrite			;   
Cw1_NoWrite:
		ret
;*******************************************************
;    1-wire (1-4)
;*******************************************************
Check_w1num:
	;	sbrc	w1flag,w1use		;   1-wire
	;	ret							;   - 
		ldi		XL,Low(w1Eecount)	;   
		ldi		XH,High(w1Eecount)
		rcall	EPROMRead
		cpi		w1rdbuf,$FF			;   - 
		brne	w1cntZero			;  - 
w1cntErase:
		ldi		w1rdbuf,0			; 
w1cntZero:
		cpi		w1rdbuf,4			;   4
		brge	w1cntErase			;  -  
w1cntNext:
		ret
;*******************************************************
;    1-wire
;*******************************************************
w1addrWrite:
		rcall	Check_w1num			;    
		inc		w1rdbuf				;C -  
		rcall	EPROMWrite			; () 
		ldi		YL,Low(w1buf1)		;    1-wire
		ldi		YH,High(w1buf1)
		rcall	GetDSaddr			;    
;*******************************************************
;   
;*******************************************************
WrAddr:	ldi		w1cnt,8				;    CRC
		mov		r1,w1cnt			; -  
WrAddrLoop:
		ld		w1rdbuf,Y+			;   1-wire
		mov		r0,w1rdbuf			;  
w1erLoop:
		rcall	EPROMWrite			;   EEPROM
		rcall	EPROMRead			;   EEPROM
		cp		w1rdbuf,r0			; 
		breq	WrAddrOk			;   - 
		dec		r1					;  
		brne	w1erLoop			;   
WrAddrError:
		cbr		w1flag,(1<<w1work)	;   1-wire
		ret							;  
WrAddrOk:
		adiw	XL,1				;   EEPROM
		dec		w1cnt				;C   
		brne	WrAddrLoop			;
		ret
;*******************************************************
;	  EEPROM
;*******************************************************
EPROMWrite:		; eadr - , edata -  (w1rdbuf
		sbic	EECR,EEWE			;  /
		rjmp	EPROMWrite
		out		EEARH,XH;eadrH			;  EEPROM
		out		EEARL,XL;eadrL			;  EEPROM
		out		EEDR,w1rdbuf			;  EEPROM
		cli					; 
		sbi		EECR,EEMWE			;   
		sbi		EECR,EEWE			; 
		rjmp	WaitForEEPROMReady
;*******************************************************
;  EEPROM
;*******************************************************
EPROMRead:
		sbic	EECR,EEWE			;  /
		rjmp	EPROMRead
		out		EEARH,XH;eadrH			;  EEPROM
		out		EEARL,XL;eadrL			;  EEPROM
		sbi		EECR,EERE
		in		w1rdbuf,EEDR
WaitForEEPROMReady:
		sbic	EECR,EEWE			;  
		rjmp	WaitForEEPROMReady
		sei							;  
		ret
;*******************************************************
