;  1-wire
;   62,5
;  
;
;
.include "m8def.inc"
.device ATMega8
; Fuse:	|  high |  |  low  |
;		1101 1001  1110 0100

;   16MHz
;**********  Variables  ************* 
.include "1wire_m8_var.asm"
;********  End Variables  ***********
.CSEG
.org 0
	rjmp	begin					;
	reti	;rjmp	Ext_INT0		; External Interrupt Request 0
	reti	;rjmp	Ext_INT1		; External Interrupt Request 1
	reti	;rjmp	Tim2_Comp		; Timer/Counter2 Compare Match A
	rjmp	Tim2_OVF		; Timer/Counter2 Overflow
	reti	;rjmp	Tim1_Capt		; Timer/Counter1 Capture Event
	reti	;rjmp	Tim1_CompA		; Timer/Counter1 Compare Match A
	reti	;rjmp	Tim1_CompB		; Timer/Counter1 Compare Match B
	reti	;rjmp	Tim1_OVF		; Timer/Counter0 Overflow
	rjmp	w1_Timer_Overflow	;rjmp	Tim0_OVF		; Timer/Counter0 Overflow
	reti	;rjmp 	SPI_STC 		; SPI Transfer Complete Handler
	reti	;rjmp	UartRXC			; USART, Rx Complete	 
	reti	;rjmp	UartDRE			; USART Data Register(UDR) Empty
	reti	;rjmp	UartTXC			; USART, Tx Complete
	reti	;rjmp	ADC 			; ADC Conversion Complete Handler
	reti	;rjmp	EERDY			; EEPROM Ready
	reti	;rjmp	ACE				; Analog Comparator Event
	reti	;rjmp	TWSI 			; Two-wire Serial Interface Handler
	reti	;rjmp	SPM_RDY 		; Store Program Memory Ready Handler
;********************************************************************************
;	INT_VECTORS_SIZE	= 19	; size in words
;********************************************************************************
.include "1-wire_timer.asm"
;*****************************************************
;    0
;    
;*****************************************************
Tim2_OVF:
		in		tempSreg,SREG		; SREG
		inc		mainCount		;    
	;	dec		DelCnt			;   
rcall	OutZnak
skipdec:
		out		SREG,tempSreg		; SREG
		reti					;  
;*****************************************************
begin:
		ldi		temp,Low(RAMEND)	; 
		out		SPL,temp
		ldi		temp,High(RAMEND)
		out		SPH,temp
;	 
		ser		temp				;    
		out		IndDir,temp
		mov		BlancReg,temp		;  BlancReg Hex FF ()
		ldi		temp,(1<<pwm)|(1<<o1w)		;PWM  
		out		DDRB,temp
		clr		temp
		out		PORTB,BlancReg;temp
		clr		mainCount		;    
		mov		OutPoz,mainCount
		inc		OutPoz
		sbi		DigDir,DigH
		sbi		DigDir,DigM
		sbi		DigDir,DigL
		;Ini_AnaComp				;  
		Ini_TMR2				;  2
		StopPWM2
;retAddrIni

		sei

;rcall	GetTemp


StartProc:

rcall	ppro



	ldi		w1del,w1wait752us		;752 
	rcall	Del64					;
	ldi		w1del,w1wait752us		;752 
	rcall	Del64					;
	ldi		w1del,w1wait752us		;752 
	rcall	Del64					;
;	ldi		w1del,w1wait752us		;752 
;	rcall	Del64					;
;	ldi		w1del,w1wait752us		;752 
;	rcall	Del64					;
;	ldi		w1del,w1wait752us		;752 
;	rcall	Del64					;
;	ldi		w1del,w1wait752us		;752 
;	rcall	Del64					;
;	ldi		w1del,w1wait752us		;752 
;	rcall	Del64					;

;sbr		flag,(1<<tReady)	; 


MainLoop:
		;tst		DelCnt			; 1
		;breq	Faul


Faul:
rjmp	StartProc
rjmp	MainLoop
;****************************************
;*****************************************************
;    
; : BlancReg, OutPoz, OutSim
; digu0 - digu2, digi0 - digi2 -  
;*****************************************************
OutZnak:
	;	in		tempSreg,SREG		; 
;		out		IndPort,BlancReg	; ,   
		in		tmp2,digPort
		andi	tmp2,DigMaskNeg
		or		tmp2,OutPoz
		out		digPort,tmp2
;		out		digPort,OutPoz		;   
		out		IndPort,OutSim		; 
			;        - Select - Case
		lsl		OutPoz				;  
		sbrs	OutPoz,3			;  6( )   
		rjmp	EndPoz1				; 
		clr		OutPoz				;    ( )
		inc		OutPoz	;		ldi		OutPoz,0b00000001	;1 
EndPoz1:
Poz1:	sbrs	OutPoz,0				;  0
		rjmp	Poz2				;,    
		lds		OutSim,IndBuf+2			;    1 
		rjmp	EndPoz				; 
Poz2:	sbrs	OutPoz,1				;  1
		rjmp	Poz3				;,    
		lds		OutSim,IndBuf+1			;    2
		rjmp	EndPoz				; 
Poz3:	;sbrs	OutPoz,2				;  2
		;rjmp	Poz4				;,    
		lds		OutSim,IndBuf			;    3 

		;rjmp	EndPoz				; 
EndPoz:	
	;	out		SREG,tempSreg		; 
		ret
;*****************************************************
;     
;     
; : tADC
; tmp, tmp2 -  0, 1  2 -  
; digu0 - digu2 -   
;   LdTable
;*****************************************************
Decode:	lds		temp,TempBuf+2	;    1
		rcall	LdTable

		ldi		temp,0b01111111
		sbrc	flag,minus
		mov		r0,temp

		sts		IndBuf+2,r0
		lds		temp,TempBuf+1	;    2
		rcall	LdTable
		sts		IndBuf+1,r0
		lds		temp,TempBuf	;    3
		rcall	LdTable
		sts		IndBuf,r0
		ret
;*****************************************************
;      ROM
; : tADC -    
; ZL, ZH - (    )
;*****************************************************
LdTable:
		andi	temp,$0F
		ldi		ZL,Low(TableAdr)	;   
		ldi		ZH,High(TableAdr)
		add		ZL,temp				;    
		clr		temp
		adc		ZH,temp				;   
		lsl		ZL					;  2
		rol		ZH
		lpm							;   
		ret
;*****************************************************
;*****************************************************
;  
;*****************************************************
TableAdr:
;     **1**
;    *     *
;    6     2
;    *     *
;     **7**
;    *     *
;    5     3
;    *     *
;     **4**   *0*
.db		0b10000001	;0		01111110		0
.db		0b11110011	;1		00001100		1
.db		0b01001001	;2		10110110		2
.db		0b01100001	;3		10011110		3
.db		0b00110011	;4		11001100		4
.db		0b00100101	;5		11011010		5
.db		0b00000101	;6		11111010		6
.db		0b11110001	;7		00001110		7
.db		0b00000001	;8		11111110		8
.db		0b00100001	;9		11011110		9
;.db		0b10010001	;A		01101110
;.db		0b00000111	;B		11111000
;.db		0b10001101	;C		01110010
;.db		0b01000011	;D		10111100
.db		0b00001101	;E		11110010		10
;.db		0b00011101	;F		11100010
.db		0b01011111	;r		10100000		11
.db		0b11111111	;Blanc					12
